import pandas as pd

def diagrama(assig,cpf):
    df = pd.read_csv('flask_app/scripts/base_de_dades.csv', decimal = ',', sep=',',header=0,skiprows=1)
    df.columns = ["Curs","Quadrimestre","CPF","Selectivitat","Àlgebra","Càlcul 1","Mecànica","Química 1","Fonaments d'Informàtica","Geometria","Càlcul 2","Termodinàmica","Química 2","Expressió Gràfica","Mitja","Barri","Renta"]
    df["CPF"] = df["CPF"].astype(str)
    df["Quadrimestre"] = df["Quadrimestre"].astype(str)
    df_filtrat = df[(df['CPF'] == cpf)]
    df_filtrat = df_filtrat.sort_values(axis = 0, by = ["Curs", "Quadrimestre"])
    df_filtrat = df_filtrat.reset_index()
    df_filtrat= df_filtrat.drop(columns = 'index') 
    
    alumnes_curs = df_filtrat['Curs'].drop_duplicates().iloc[:].index #ens quedem amb l'index del cpf de cada alumne
    alumnes_index_curs = alumnes_curs.to_list()[1:] #posem els index de on comença cada cpf en una llista

    ll=[]
    idx=0
    for curs in alumnes_index_curs:    #entrem en la llista de index
        
        curs_df = df_filtrat.iloc[idx:curs]
        idx = curs 
        
        curs_dfQ1 = curs_df[curs_df['Quadrimestre'] == '1']
        curs_dfQ2 = curs_df[curs_df['Quadrimestre'] == '2']
        
        
        if curs_dfQ1[assig].count() > 0:
            
            mitjaQ1 = curs_dfQ1[assig].astype(float).mean()
            curs = curs_dfQ1['Curs'].astype(str)
            quad = curs_dfQ1['Quadrimestre'].astype(str)
            val1 = curs.values[0]
            val2 = quad.values[0]
            T1 = (val1+' Q'+val2)
            ll.append([T1,mitjaQ1])
            
        if curs_dfQ2[assig].count() > 0:
            mitjaQ2 = curs_dfQ2[assig].astype(float).mean()
            curs = curs_dfQ2['Curs'].astype(str)
            quad = curs_dfQ2['Quadrimestre'].astype(str)
            val1 = curs.values[0]
            val2 = quad.values[0]
            T2 = (val1+'/Q'+val2)
            ll.append([T2,mitjaQ2])

    return ll
    
#print(diagrama('Algebra','8024'))