import pandas as pd
import scipy
from scipy.stats import pearsonr

def histograma(assig,renta_min,renta_max):
    df = pd.read_csv('flask_app/scripts/base_de_dades.csv', decimal = ',', sep=',',header=0,skiprows=1)
    df.columns = ["Curs","Quadrimestre","CPF","Selectivitat","Àlgebra","Càlcul 1","Mecànica","Química 1","Fonaments d'Informàtica","Geometria","Càlcul 2","Termodinàmica","Química 2","Expressió Gràfica","Mitja","Barri","Renta"]
    df["Renta"] = df["Renta"].astype(float)
    df_filtrat = df[(df["Renta"] > renta_min) & (df["Renta"] < renta_max)]
    df_filtrat = df_filtrat.dropna( axis=0, how='any')
    x = df_filtrat['Renta'].values.tolist()
    y = df_filtrat[assig].astype(float).values.tolist()
    corr, p = scipy.stats.pearsonr(x, y)
    corr = round(corr, 4)
    p = round(p, 4)
    l_hist=[['Renta',assig]]
    l_cpf=df_filtrat['Renta'].astype(str).to_list()
    l_assig=df_filtrat[assig].astype(float).to_list()


    for linea in range(len(l_cpf)):
        l_aux=[]
        l_aux.append(l_cpf[linea]),l_aux.append(l_assig[linea])
        l_hist.append(l_aux)
        llista = df_filtrat[[assig]].astype(float).describe().values.tolist()
        llista.pop(0)
        i = 0
        for stat in ['Mitja','Desviació','Min','25%','50%','75%','max']:
            llista[i].insert(0,stat)
            i = i+1
        llista.append(['Correlació',corr])
        llista.append(['p-valor',p])
        if llista[8][1] < 0.05 and llista[8][1] > -0.05:
            llista.append(['Significatiu',1])
        else:
            llista.append(['Significatiu',0])
    return l_hist,llista

#print(histograma('Algebra',20000,25000))

