import pandas as pd

def ranking(assig):
    df = pd.read_csv('flask_app/scripts/base_de_dades.csv', decimal = ',', sep=',',header=0,skiprows=1)
    df.columns = ["Curs","Quadrimestre","CPF","Selectivitat","Àlgebra","Càlcul 1","Mecànica","Química 1","Fonaments d'Informàtica","Geometria","Càlcul 2","Termodinàmica","Química 2","Expressió Gràfica","Mitja","Barri","Renta"]
    df_aux = df[[assig,'Barri','CPF']]

    alumnes_cpf = df_aux['CPF'].drop_duplicates().iloc[:].index #ens quedem amb l'index del cpf de cada alumne
    alumnes_index_cpf = alumnes_cpf.to_list()[1:] #posem els index de on comença cada cpf en una llista

    ll=[]
    idx=0
    for cpf in alumnes_index_cpf:    #entrem en la llista de index
        cpf_df = df_aux.iloc[idx:cpf]
        idx = cpf 
        if cpf_df[assig].count() > 10:
            assignatura = cpf_df[assig].astype(float)
            barri = cpf_df['Barri'].astype(str)
            val = barri.values
            ll.append([assignatura.mean(), val[0]])
    df_mitjes = pd.DataFrame(ll, columns =[assig, 'Barri']) 
    df_mitjes = df_mitjes.sort_values(axis=0, by=assig, ascending = False).reset_index(drop = True)
    df_mitjes.index += 1
    df_mitjes[assig] = df_mitjes[assig].round(3)
    millors = df_mitjes.head(10).values.tolist()
    df_mitjes = df_mitjes.sort_values(axis=0, by=assig).reset_index(drop = True, level = 0)
    df_mitjes.index += 1
    pitjors = df_mitjes.head(10).values.tolist()
    return millors, pitjors

#print(ranking('Algebra'))


def ranking_percentatge_fase_inicial(assig):
    df = pd.read_csv('flask_app/scripts/base_de_dades.csv', decimal = ',', sep=',',header=0,skiprows=1)
    df2 = pd.read_csv('flask_app/scripts/base_de_dades2.csv', decimal = ',', sep=',',header=0,skiprows=1)
    df.columns = ["Curs","Quadrimestre","CPF","Selectivitat","Àlgebra","Càlcul 1","Mecànica","Química 1","Fonaments d'Informàtica","Geometria","Càlcul 2","Termodinàmica","Química 2","Expressió Gràfica","Mitja","Barri","Renta"]
    df2.columns = ["Curs","Quadrimestre","CPF","Selectivitat","Àlgebra","Càlcul 1","Mecànica","Química 1","Fonaments d'Informàtica","Geometria","Càlcul 2","Termodinàmica","Química 2","Expressió Gràfica","Mitja","Barri","Renta"]
    
    df_aux = df[[assig,'Barri','CPF']]
    df_aux2 = df2[[assig,'Barri','CPF']]
    df_aux2 = df_aux2.sort_values('CPF').reset_index(drop = 'True')
    
    
    alumnes_cpf = df_aux['CPF'].drop_duplicates().iloc[:].index #ens quedem amb l'index del cpf de cada alumne
    alumnes_index_cpf = alumnes_cpf.to_list()[1:] #posem els index de on comença cada cpf en una llista

    
    ll=[]
    idx=0
    for cpf in alumnes_index_cpf:    #entrem en la llista de index
        cpf_df = df_aux.iloc[idx:cpf]
        idx = cpf 
        if cpf_df[assig].count() > 15:
            assignatura = cpf_df[assig].astype(float)
            barri = cpf_df['Barri'].astype(str)
            val = barri.values
            ll.append([assignatura.count(), val[0]])
            
            
    alumnes_cpf2 = df_aux2['CPF'].drop_duplicates().iloc[:].index #ens quedem amb l'index del cpf de cada alumne
    alumnes_index_cpf2 = alumnes_cpf2.to_list()[1:] #posem els index de on comença cada cpf en una llista

    ll2=[]
    idx2=0
    for cpf in alumnes_index_cpf2:    #entrem en la llista de index
        cpf_df = df_aux2.iloc[idx2:cpf]
        idx2 = cpf 
    

        if cpf_df[assig].count() > 15:
            assignatura = cpf_df[assig].astype(float)
            barri = cpf_df['Barri'].astype(str)
            val = barri.values
            ll2.append([assignatura.count(), val[0]])

    df_numero = pd.DataFrame(ll, columns =['Numero', 'Barri']) 
    df_numero2 = pd.DataFrame(ll2, columns =['Numero_total', 'Barri']) 
    df = pd.merge(df_numero,df_numero2[['Numero_total','Barri']],on='Barri')
    df_aux3 = df['Numero']/df['Numero_total']
    df['Percentatge'] = df_aux3
    
    df = df.drop(columns=['Numero','Numero_total'])
    df = df[['Percentatge','Barri']]
    df = df.sort_values(by = 'Percentatge' , ascending = False).reset_index(drop = True, level = 0)
    df.index = df.index + 1
    df['Percentatge'] = df['Percentatge'].multiply(other=100).round(decimals=2)
    millors = df.head(10).values.tolist()
    df = df.sort_values(by = 'Percentatge').reset_index(drop = True, level = 0)
    df.index = df.index+ 1
    pitjors = df.head(10).values.tolist()

    return millors, pitjors

#print(ranking_percentatge_fase_inicial('Algebra'))

def ranking_percentatge_aprovats(assig):
    df = pd.read_csv('flask_app/scripts/base_de_dades.csv', decimal = ',', sep=',',header=0,skiprows=1)
    df.columns = ["Curs","Quadrimestre","CPF","Selectivitat","Àlgebra","Càlcul 1","Mecànica","Química 1","Fonaments d'Informàtica","Geometria","Càlcul 2","Termodinàmica","Química 2","Expressió Gràfica","Mitja","Barri","Renta"]
    df_aux = df[[assig,'Barri','CPF']]
    
    alumnes_cpf = df_aux['CPF'].drop_duplicates().iloc[:].index #ens quedem amb l'index del cpf de cada alumne
    alumnes_index_cpf = alumnes_cpf.to_list()[1:] #posem els index de on comença cada cpf en una llista

    
    ll=[]
    idx=0
    for cpf in alumnes_index_cpf:    #entrem en la llista de index
        cpf_df = df_aux.iloc[idx:cpf]
        idx = cpf 
        if cpf_df[assig].count() > 15:
            assignatura = cpf_df[assig].astype(float)
            barri = cpf_df['Barri'].astype(str)
            total = assignatura
            assignatura = assignatura[assignatura >= 5]
            percentatge_aprovat = assignatura.count()/ total.count()
            val = barri.values
            ll.append([percentatge_aprovat, val[0]])
    df = pd.DataFrame(ll, columns =['Numero', 'Barri'])
    df = df.sort_values(by = 'Numero' , ascending = False).reset_index(drop = True, level = 0) 
    df.index = df.index+1
    df['Numero'] = df['Numero'].multiply(other=100).round(decimals=2)
    millors = df.head(10).values.tolist()
    df = df.sort_values(by = 'Numero').reset_index(drop = True, level = 0)
    df.index = df.index+1
    pitjors = df.head(10).values.tolist()
    
    return millors, pitjors
    
            
            
    
#print(ranking_percentatge_aprovats('Algebra'))