from flask import render_template
from flask_app import app
from flask import request
from flask_app.scripts import histograma, boxplot, rankings, histograma_cpf, boxplot_cpf, diagrama, taula_index
import pandas as pd

@app.route('/') 
@app.route('/index') 
def index():
    taulaind = taula_index.taula()
    return render_template('index.html', taula = taulaind)
    

@app.route('/BuscadorCPF')
def buscadorCPF():
    return render_template('formulariCPF.html')    

@app.route('/stats_CPF', methods=['POST'])
def stats_cpf():
    CPF = request.form['CPF']
    assignatura = request.form['assig']
    l_hist = histograma_cpf.histograma_cpf(assignatura, CPF)
    l_box = boxplot_cpf.boxplot_cpf(assignatura,CPF)
    ll = diagrama.diagrama(assignatura,CPF)

    return render_template('stats_CPF.html', dades = l_hist, dades2 = l_box, llista = ll)
     
@app.route('/ranking', methods=['POST']) 
def ranking():
    assignatura = request.form['assig']
    millors_notes, pitjors_notes = rankings.ranking(assignatura)
    millors_percentatge_faseini, pitjors_percentatge_faseini = rankings.ranking_percentatge_fase_inicial(assignatura)
    millors_percentatge_aprovat, pitjors_percentatge_aprovat = rankings.ranking_percentatge_aprovats(assignatura)

    return render_template('ranking.html', taula1 = millors_notes, taula2 = pitjors_notes,
    taula3 = millors_percentatge_faseini, taula4 = pitjors_percentatge_faseini,
    taula5 = millors_percentatge_aprovat, taula6 = pitjors_percentatge_aprovat,
    assig = assignatura)

@app.route('/Assignatures', methods=['POST'])
def assignatures():
    assignatura = request.form['assig']
    l_hist,text_dades = histograma.histograma(assignatura,0,150000)
    l_box = boxplot.boxplot(assignatura,0,150000)
    return render_template('stats_completes.html', dades = l_hist, llista = text_dades, dades2 = l_box)


